import { BehaviorSubject } from 'rxjs';
import { ApplicationId } from './application-id.enum';
import { AuthUser, Tenant } from './models';
export declare class AuthService {
    private location;
    set user(user: AuthUser);
    get user(): AuthUser;
    private _user;
    loginUrl: string;
    logoutUrl: string;
    logoutRedirectUiUrl: string;
    userLoaded: BehaviorSubject<AuthUser>;
    constructor(location: any);
    logout(): void;
    logoutForSubrogation(superUser: string, surrogate: string): void;
    logoutAndRedirectToUI(): void;
    logoutAndRedirectToUiForUser(email: string): void;
    logoutWithEmailWithOutRedirectToUi(email: string): void;
    getAnyTenantIdentifier(): string;
    getTenantByIdentifier(identifier: number): Tenant;
    getTenantByAppAndIdentifier(appId: ApplicationId, tenantIdentifier: number): Tenant;
}
